// Code generated by SQLBoiler (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package postgres

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/randomize"
	"github.com/volatiletech/sqlboiler/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testDriverTokens(t *testing.T) {
	t.Parallel()

	query := DriverTokens()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testDriverTokensDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testDriverTokensQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := DriverTokens().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testDriverTokensSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := DriverTokenSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testDriverTokensExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := DriverTokenExists(ctx, tx, o.ID)
	if err != nil {
		t.Errorf("Unable to check if DriverToken exists: %s", err)
	}
	if !e {
		t.Errorf("Expected DriverTokenExists to return true, but got false.")
	}
}

func testDriverTokensFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	driverTokenFound, err := FindDriverToken(ctx, tx, o.ID)
	if err != nil {
		t.Error(err)
	}

	if driverTokenFound == nil {
		t.Error("want a record, got nil")
	}
}

func testDriverTokensBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = DriverTokens().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testDriverTokensOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := DriverTokens().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testDriverTokensAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	driverTokenOne := &DriverToken{}
	driverTokenTwo := &DriverToken{}
	if err = randomize.Struct(seed, driverTokenOne, driverTokenDBTypes, false, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}
	if err = randomize.Struct(seed, driverTokenTwo, driverTokenDBTypes, false, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = driverTokenOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = driverTokenTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := DriverTokens().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testDriverTokensCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	driverTokenOne := &DriverToken{}
	driverTokenTwo := &DriverToken{}
	if err = randomize.Struct(seed, driverTokenOne, driverTokenDBTypes, false, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}
	if err = randomize.Struct(seed, driverTokenTwo, driverTokenDBTypes, false, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = driverTokenOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = driverTokenTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func driverTokenBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *DriverToken) error {
	*o = DriverToken{}
	return nil
}

func driverTokenAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *DriverToken) error {
	*o = DriverToken{}
	return nil
}

func driverTokenAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *DriverToken) error {
	*o = DriverToken{}
	return nil
}

func driverTokenBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *DriverToken) error {
	*o = DriverToken{}
	return nil
}

func driverTokenAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *DriverToken) error {
	*o = DriverToken{}
	return nil
}

func driverTokenBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *DriverToken) error {
	*o = DriverToken{}
	return nil
}

func driverTokenAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *DriverToken) error {
	*o = DriverToken{}
	return nil
}

func driverTokenBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *DriverToken) error {
	*o = DriverToken{}
	return nil
}

func driverTokenAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *DriverToken) error {
	*o = DriverToken{}
	return nil
}

func testDriverTokensHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &DriverToken{}
	o := &DriverToken{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, driverTokenDBTypes, false); err != nil {
		t.Errorf("Unable to randomize DriverToken object: %s", err)
	}

	AddDriverTokenHook(boil.BeforeInsertHook, driverTokenBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	driverTokenBeforeInsertHooks = []DriverTokenHook{}

	AddDriverTokenHook(boil.AfterInsertHook, driverTokenAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	driverTokenAfterInsertHooks = []DriverTokenHook{}

	AddDriverTokenHook(boil.AfterSelectHook, driverTokenAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	driverTokenAfterSelectHooks = []DriverTokenHook{}

	AddDriverTokenHook(boil.BeforeUpdateHook, driverTokenBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	driverTokenBeforeUpdateHooks = []DriverTokenHook{}

	AddDriverTokenHook(boil.AfterUpdateHook, driverTokenAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	driverTokenAfterUpdateHooks = []DriverTokenHook{}

	AddDriverTokenHook(boil.BeforeDeleteHook, driverTokenBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	driverTokenBeforeDeleteHooks = []DriverTokenHook{}

	AddDriverTokenHook(boil.AfterDeleteHook, driverTokenAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	driverTokenAfterDeleteHooks = []DriverTokenHook{}

	AddDriverTokenHook(boil.BeforeUpsertHook, driverTokenBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	driverTokenBeforeUpsertHooks = []DriverTokenHook{}

	AddDriverTokenHook(boil.AfterUpsertHook, driverTokenAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	driverTokenAfterUpsertHooks = []DriverTokenHook{}
}

func testDriverTokensInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testDriverTokensInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(driverTokenColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testDriverTokenToOneDriverUsingDriver(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local DriverToken
	var foreign Driver

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, driverTokenDBTypes, false, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, driverDBTypes, false, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.DriverID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Driver().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := DriverTokenSlice{&local}
	if err = local.L.LoadDriver(ctx, tx, false, (*[]*DriverToken)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Driver == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Driver = nil
	if err = local.L.LoadDriver(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Driver == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testDriverTokenToOneSetOpDriverUsingDriver(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a DriverToken
	var b, c Driver

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, driverTokenDBTypes, false, strmangle.SetComplement(driverTokenPrimaryKeyColumns, driverTokenColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Driver{&b, &c} {
		err = a.SetDriver(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Driver != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.DriverTokens[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.DriverID != x.ID {
			t.Error("foreign key was wrong value", a.DriverID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.DriverID))
		reflect.Indirect(reflect.ValueOf(&a.DriverID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if a.DriverID != x.ID {
			t.Error("foreign key was wrong value", a.DriverID, x.ID)
		}
	}
}

func testDriverTokensReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testDriverTokensReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := DriverTokenSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testDriverTokensSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := DriverTokens().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	driverTokenDBTypes = map[string]string{`ID`: `bigint`, `DriverID`: `bigint`, `AccessToken`: `character varying`, `DTCreated`: `timestamp without time zone`, `DTLastUsage`: `timestamp without time zone`}
	_                  = bytes.MinRead
)

func testDriverTokensUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(driverTokenPrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(driverTokenColumns) == len(driverTokenPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testDriverTokensSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(driverTokenColumns) == len(driverTokenPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &DriverToken{}
	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, driverTokenDBTypes, true, driverTokenPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(driverTokenColumns, driverTokenPrimaryKeyColumns) {
		fields = driverTokenColumns
	} else {
		fields = strmangle.SetComplement(
			driverTokenColumns,
			driverTokenPrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := DriverTokenSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}

func testDriverTokensUpsert(t *testing.T) {
	t.Parallel()

	if len(driverTokenColumns) == len(driverTokenPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	// Attempt the INSERT side of an UPSERT
	o := DriverToken{}
	if err = randomize.Struct(seed, &o, driverTokenDBTypes, true); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Upsert(ctx, tx, false, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert DriverToken: %s", err)
	}

	count, err := DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}

	// Attempt the UPDATE side of an UPSERT
	if err = randomize.Struct(seed, &o, driverTokenDBTypes, false, driverTokenPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize DriverToken struct: %s", err)
	}

	if err = o.Upsert(ctx, tx, true, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert DriverToken: %s", err)
	}

	count, err = DriverTokens().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}
}
